<%-- $Id: overview.jsp 6305 2013-08-09 09:10:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.DiskUsage"
	import="net.sf.basedb.core.DiskUsageStatistics"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Expression"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
	private static final Item itemType = Item.DISKUSAGE;
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	DiskUsageStatistics du = (DiskUsageStatistics)sc.getSessionSetting("diskUsageStatistics");
	if (du == null)
	{
		du = DiskUsage.getStatistics(dc);
		sc.setSessionSetting("diskUsageStatistics", du);
	}
	du.setDbControl(dc);
	List<QuotaType> quotaTypes = du.getQuotaTypes();
	DiskUsageStatistics.Summary summary = du.getTotalSummary();
	%>
	<base:page title="Disk usage" id="overview-page">
	<base:head scripts="tabcontrol-2.js,~diskusage.js" styles="headertabcontrol.css">
		<style>
		table.special
		{
			border-collapse: collapse;
			width: auto;
		}
		table.special td, table.special tr:first-child th
		{
			text-align: right;
			border-right: 1px dotted #A0A0A0;
		}
		</style>
	</base:head>
	<base:body>
		<h1>Disk usage</h1>
	
		<t:tabcontrol 
			id="main" 
			subclass="mastertabcontrol content" 
			active="overview">
		<t:tab id="overview" title="Overview" data-cmd="Overview">

			<table class="special fullform bottomborder rightborder">
			<tr>
				<th style="width: 10em;"></th>
				<th style="width: 12em;">Total</th>
				<th style="width: 12em;">Primary</th>
				<th style="width: 12em;">Secondary</th>
				<th style="width: 12em;">Offline</th>
				<th style="width: 12em;">External</th>
			</tr>
			<tr style="border-top: 1px solid #A0A0A0;" class="highlight">
				<th>Total</th>
				<td><%=Values.formatBytes(summary.getTotal())%></td>
				<td><%=Values.formatBytes(summary.getTotal(Location.PRIMARY))%></td>
				<td><%=Values.formatBytes(summary.getTotal(Location.SECONDARY))%></td>
				<td><%=Values.formatBytes(summary.getTotal(Location.OFFLINE))%></td>			
				<td><%=Values.formatBytes(summary.getTotal(Location.EXTERNAL))%></td>			
			</tr>
			<%
			for (QuotaType qt : quotaTypes)
			{
				%>
				<tr class="highlight">
					<th><%=HTML.encodeTags(qt.getName())%></th>
					<td><%=Values.formatBytes(summary.getTotal(qt))%></td>
					<td><%=Values.formatBytes(summary.getTotal(qt, Location.PRIMARY))%></td>
					<td><%=qt.hasSecondaryLocation() ? Values.formatBytes(summary.getTotal(qt, Location.SECONDARY)) : "n/a"%></td>
					<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.OFFLINE)) : "n/a"%></td>
					<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.EXTERNAL)) : "n/a"%></td>
				</tr>
				<%
			}
			%>
			</table>
		</t:tab>
		<t:tab id="users" title="Per user" data-cmd="ListUsers" />
		<t:tab id="groups" title="Per group" data-cmd="ListGroups" />
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
