<%-- $Id:tree.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.extensions.Registry"
	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.Action"
	import="net.sf.basedb.util.extensions.manager.ExtensionsFile"
	import="net.sf.basedb.util.extensions.manager.ExtensionKey"
	import="net.sf.basedb.util.extensions.manager.ExtensionPointKey"
	import="net.sf.basedb.util.extensions.xml.PluginInfo"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.core.plugin.About"
	import="java.util.List"
	import="java.util.Iterator"
	import="java.util.Collections"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
JSONObject newJoustExtensionPoint(JSONObject jsonParent, ExtensionsControl ec, ExtensionPoint ep, ExtensionsFile ef)
{
	String id = ep.getId();
	String name = ep.getName();
	if (name == null) name = id;
	String icon = ec.isEnabled(ep) ? "ExtensionPoint" : "ExtensionPointDisabled";
	if ((ef != null && ef.hasError()) || ec.getLastExtensionPointError(id) != null) 
	{
		icon = "ExtensionPointError";
	}
	JSONObject json = newJoustEntry(jsonParent, icon, HTML.encodeTags(name), id);
	json.put("type", "extension-point");
	return json;
}

JSONObject newJoustExtension(JSONObject jsonParent, ExtensionsControl ec, Extension ext, ExtensionsFile ef, boolean inGroup, boolean showFile)
{
	String id = ext.getId();
	About about = ext.getAbout();
	String name = HTML.encodeTags(about == null || about.getName() == null ? id : about.getName());
	if (inGroup) name = ext.getId().substring(ext.getId().indexOf(":"));
	if (showFile)
	{
		name += " <span class=\"itemref\">[" + HTML.encodeTags(ef.getName()) + "]</span>";
	}
	else
	{
		name += " <span class=\"itemref\">[" + HTML.encodeTags(ec.getExtensionPoint(ext.getExtends()).getName()) + "]</span>";
	}
	String icon = ec.isEnabled(ext) ? "Extension" : "ExtensionDisabled";
	if ((ef != null && ef.hasError()) || ec.getLastExtensionError(id) != null)
	{
		icon = "ExtensionError";
	}
	else if (ec.checkUnsafeScriptableUsage(ext))
	{
		icon = "ExtensionWarning";
	}
	
	JSONObject json = newJoustEntry(jsonParent, icon, name, id);
	json.put("type", "extension");
	return json;
}

JSONObject newJoustFile(JSONObject jsonParent, ExtensionsFile ef, ExtensionsControl ec)
{
	String efName = ef.getName();
	String icon = ef.isJar() ? "JarFile" : "XmlFile";
	if (ef.hasError()) 
	{
		icon += "Error";
	}
	else if (ec.checkUnsafeScriptableUsage(ef).size() > 0) 
	{
		icon += "Warning";
	}
	if (ef.checkModified()) icon += "Modified";
	
	JSONObject json = newJoustEntry(jsonParent, icon, HTML.encodeTags(efName), efName);
	json.put("id", efName);
	json.put("type", "file");
	json.put("fileUri", ef.getURI().toString());
	return json;
}

JSONObject newJoustExtensionGroup(JSONObject jsonParent, ExtensionsControl ec, Extension ext, String groupId)
{
	String id = ext.getId();
	About about = ext.getAbout();
	String name = about == null || about.getName() == null ? id : about.getName();
	String icon = "Folder";
	JSONObject json = newJoustEntry(jsonParent, icon, HTML.encodeTags(name), groupId);
	json.put("type", "group");
	return json;
}

JSONObject newJoustPlugin(JSONObject jsonParent, ExtensionsControl ex, PluginInfo info, ExtensionsFile ef)
{
	String id = info.getClassName();
	About about = info.getAbout();
	String name = HTML.encodeTags(about == null || about.getName() == null ? id : about.getName());
	if (info.getType() != null)
	{
		name += " <span class=\"itemref\">[" + info.getType().toString() + "]</span>";
	}
	String icon = info.isDisabled() ? "PluginDisabled" : "Plugin";
	if ((ef != null && ef.hasError()) || !info.isInstalled())
	{
		icon = "PluginError";
	}
	
	JSONObject json = newJoustEntry(jsonParent, icon, name, id);
	json.put("type", "plugin");
	json.put("className", info.getClassName());
	return json;
}

JSONObject newJoustEntry(JSONObject jsonParent, String icon, String text, String id)
{
	JSONObject jsonJoust = new JSONObject();
	jsonJoust.put("icon", icon);
	jsonJoust.put("text", text);
	jsonJoust.put("id", "joust-"+System.identityHashCode(jsonJoust));
	jsonJoust.put("externalId", id);
	if (jsonParent != null)
	{
		JSONArray jsonChildren = (JSONArray)jsonParent.get("children");
		if (jsonChildren == null)
		{
			jsonChildren = new JSONArray();
			jsonParent.put("children", jsonChildren);
		}
		jsonChildren.add(jsonJoust);
	}
	return jsonJoust;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;

// Build the Joust menu tree
JSONArray jsonJoust = new JSONArray();

// Two ROOT items:
JSONObject jsonByExtPoint = newJoustEntry(null, "Root", "By extension point", "root.by-extension-point");
jsonByExtPoint.put("isOpen", 1);
JSONObject jsonByFile = newJoustEntry(null, "Root", "By file", "root.by-file");
jsonByFile.put("isOpen", 1);

// Group some extension points inside sub-folders
JSONObject jsonToolbars = newJoustEntry(jsonByExtPoint, "Folder", "Toolbars", "by-extension-point.toolbars");
JSONObject jsonEditDialogs = newJoustEntry(jsonByExtPoint, "Folder", "Edit dialogs", "by-extension-point.edit-dialogs");
JSONObject jsonListColumns = newJoustEntry(jsonByExtPoint, "Folder", "List columns", "by-extension-point.list-columns");

jsonJoust.add(jsonByExtPoint);
jsonJoust.add(jsonByFile);

ExtensionsControl ec = ExtensionsControl.get(dc);
List<ExtensionPoint<?>> extensionPoints = ec.getExtensionPoints();
Collections.sort(extensionPoints, Registry.EXTENSIONPOINT_COMPARATOR);
for (ExtensionPoint ep : extensionPoints)
{
	String id = ep.getId();
	JSONObject jsonParent = jsonByExtPoint;
	if (id.startsWith("net.sf.basedb.clients.web.toolbar.")) jsonParent = jsonToolbars;
	if (id.startsWith("net.sf.basedb.clients.web.tabcontrol.edit.")) jsonParent = jsonEditDialogs;
	if (id.startsWith("net.sf.basedb.clients.web.onsave.")) jsonParent = jsonEditDialogs;
	if (id.startsWith("net.sf.basedb.clients.web.listcolumn.")) jsonParent = jsonListColumns;
	
	JSONObject jsonEp = newJoustExtensionPoint(jsonParent, ec, ep, ec.getFileByObjectKey(new ExtensionPointKey(ep)));

	List<Extension<?>> extensions = ec.getExtensions(ep.getId());
	Collections.sort(extensions, Registry.EXTENSION_COMPARATOR);
	for (Extension ext : extensions)
	{
		newJoustExtension(jsonEp, ec, ext, ec.getFileByObjectKey(new ExtensionKey(ext)), false, true);
	}
}

for (ExtensionsFile ef : ec.getFiles())
{
	if (!ef.isInstalled()) continue;
	
	JSONObject jsonFile = newJoustFile(jsonByFile, ef, ec);

	List<ExtensionPoint> eps = ef.getObjectsOfClass(ExtensionPoint.class);
	Collections.sort(eps, Registry.EXTENSIONPOINT_COMPARATOR);
	for (ExtensionPoint ep : eps)
	{
		newJoustExtensionPoint(jsonFile, ec, ep, ef);
	}
	
	List<Extension> exts = ef.getObjectsOfClass(Extension.class);
	Collections.sort(exts, Registry.EXTENSION_COMPARATOR);
	String currentGroupId = null;
	JSONObject jsonGroup = null;
	
	for (Extension ext : exts)
	{
		int groupIndex = ext.getId().indexOf(":");
		// ID:s containing ':' should be grouped
		if (groupIndex > 0)
		{
			String groupId = ext.getId().substring(0, groupIndex);
			if (!groupId.equals(currentGroupId))
			{
				currentGroupId = groupId;
				jsonGroup = newJoustExtensionGroup(jsonFile, ec, ext, currentGroupId);
			}
		}
		else
		{
			currentGroupId = null;
			jsonGroup = null;
		}
		newJoustExtension(jsonGroup != null ? jsonGroup : jsonFile, ec, ext, ef, jsonGroup != null, false);
	}
	List<PluginInfo> plugins = ef.getObjectsOfClass(PluginInfo.class);
	Collections.sort(plugins, PluginInfo.NAME_COMPARATOR);
	for (PluginInfo info : plugins)
	{
		newJoustPlugin(jsonFile, ec, info, ef);
	}
}


try
{
	dc = sc.newDbControl();
	%>
	<base:page title="" type="iframe">
	<base:head scripts="joust-2.js,dragdrop.js,~tree.js" styles="joust-2.css">
	<style>
	.itemref 
	{
		font-size: 0.85em;
		color: #666666;
	}
	.selected .itemref 
	{
		color: #E8E8E8;
	}
	</style>
	</base:head>
		<base:body>
		<div id="main" class="absolutefull auto-init" data-auto-init="drag-support">
			<div id="joust" class="joust absolutefull"
				data-joust-tree="<%=HTML.encodeTags(jsonJoust.toJSONString()) %>"
				style="overflow: auto;">
			</div>
		</div>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
