<%-- $Id: list_biowells.jsp 6524 2014-09-03 06:33:12Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOWELL;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int bioPlateId = Values.getInt(request.getParameter("bioplate_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("biowell", "biowells");
final DbControl dc = sc.newDbControl();
ItemResultIterator<BioWell> biowells = null;

Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);

WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);

try
{
	final BioPlate bioplate = BioPlate.getById(dc, bioPlateId);
	final BioPlateType bioPlateType = bioplate.getBioPlateType();
	final boolean createPermission = bioplate.hasPermission(Permission.WRITE);
	final boolean deletePermission = createPermission;
	final BioWell.LockMode lockMode = bioPlateType.getLockMode();

	Enumeration<String, String> rows = new Enumeration<String,String>();
	for (int r = 0; r < bioplate.getPlateGeometry().getRows() && r < 256; r++)
	{
		rows.add(Integer.toString(r), rowFormatter.format(r));
	}
	
	Enumeration<String, String> columns = new Enumeration<String,String>();
	for (int c = 0; c < bioplate.getPlateGeometry().getColumns() && c < 256; c++)
	{
		columns.add(Integer.toString(c), columnFormatter.format(c));
	}
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	
	try
	{
		final ItemQuery<BioWell> query = Base.getConfiguredQuery(dc, cc, true, bioplate.getBioWells(), mode);
		query.join(Hql.leftJoin(null, "bioMaterial", "mbm", null, true));
		query.join(Hql.leftJoin("mbm", "creationEvent", "evt", null, true));
		if (!"row".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("row")));
		if (!"column".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("column")));
		biowells = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioplate);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,tabcontrol-2.js,~biowells.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<%
		if (!mode.isSelectionMode())
		{
			%>
			<p:path><p:pathelement 
				title="Bioplates" href="<%="../index.jsp?ID="+ID%>" 
				/><p:pathelement title="<%=HTML.encodeTags(bioplate.getName())%>" 
				/></p:path>
			<%
		}
		else
		{
			%>
			<h1><%=title%></h1>
			<%
		}
		%>
		<t:tabcontrol 
			id="main"
			subclass="content mastertabcontrol"
			active="biowells" 
			notabs="<%=mode.isSelectionMode()%>"
			>
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations" />				
		<t:tab id="biowells" title="Wells">
		<tbl:table 
			id="biowells" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="bioplate_id" 
				value="<%=String.valueOf(bioPlateId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="row"
				property="row"
				datatype="int"
				title="Row"
				sortable="true" 
				filterable="true"
				enumeration="<%=rows%>"
				exportable="true"
				show="always" 
				formatter="<%=rowFormatter%>"
			/>
			<tbl:columndef 
				id="column"
				property="column"
				datatype="int"
				title="Column"
				sortable="true" 
				filterable="true"
				enumeration="<%=columns%>"
				exportable="true"
				show="always" 
				formatter="<%=columnFormatter%>"
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>	
			<tbl:columndef 
				id="bioMaterial.name"
				property="$mbm.name"
				exportproperty="bioMaterial.name"
				datatype="string"
				title="[Biomtrl] Name"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="bioMaterial.description"
				property="$mbm.description"
				exportproperty="bioMaterial.description"
				datatype="string"
				title="[Biomtrl] Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="bioMaterial.entryDate"
				property="$evt.entryDate"
				exportproperty="bioMaterial.creationEvent.entryDate"
				datatype="date"
				title="[Biomtrl] Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef
				id="bioMaterialList"
				property="@bioMaterial.bioMaterialLists"
				datatype="int"
				title="[Biomtrl] Biomaterial list"
				filterable="true"
				enumeration="<%=Base.getBioMaterialListsEnum(dc, null, Include.ALL)%>"
				multiple="false"
			/>
			<tbl:columndef 
				id="originalBioMaterial.name"
				property="originalBioMaterial.name"
				datatype="string"
				title="[Biomtrl] Original"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					visible="<%=mode.hasToolbar()%>"
					subclass="bottomborder"
					>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=biowells == null ? 0 : biowells.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasCheck()%>"
							><base:icon 
								id="check.uncheck"
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							visible="<%=mode.hasIcons()%>"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (biowells != null)
					{						
						while (biowells.hasNext())
						{
							BioWell item = biowells.next();
							int itemId = item.getId();
							String coordinate = rowFormatter.format(item.getRow()) + columnFormatter.format(item.getColumn());
							index++;
							numListed++;
							MeasuredBioMaterial bioMaterial = null;
							BioMaterialEvent creationEvent = null;
							boolean editWellPermission = item.hasPermission(Permission.USE);
							try
							{
								bioMaterial = item.getBioMaterial();
								if (bioMaterial != null)
								{
									creationEvent = bioMaterial.getCreationEvent();
									editWellPermission &= bioMaterial.hasPermission(Permission.WRITE) && !bioMaterial.isLockedInWell();
								}
								else
								{
									editWellPermission &= item.canAddBioMaterial();
								}
							}
							catch (PermissionDeniedException ex)
							{
								editWellPermission = false;
							}
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=coordinate%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=coordinate%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
								
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="row">
									<%
									if (mode.isSelectionMode())
									{
										%>
										<div 
											class="link table-item"
											data-item-id="<%=itemId%>"
											tabindex="0"
											title="Select this item">
											<tbl:cellvalue value="<%=item.getRow()%>" />
										</div>
									<%
									}
									else
									{
										%><tbl:cellvalue value="<%=item.getRow()%>" /><%
									}
									%>
								</tbl:cell>
								<tbl:cell column="column" value="<%=item.getColumn()%>" />
								<tbl:cell column="bioMaterial.name">
									<base:propertyvalue 
											item="<%=item%>" 
											property="bioMaterial"
											enableEditLink="<%=mode.hasEditLink()%>" 
											enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/>
									<base:icon 
										visible="<%=editWellPermission%>"
										subclass="link auto-init"
										data-auto-init="item-link" 
										data-item-type="BIOWELL" 
										data-item-id="<%=itemId %>"
										image="edit.png"
										tooltip="<%=bioMaterial == null ? "Add biomaterial to this well" : "Change the biomaterial in this well"%>"
									/>
									<base:icon 
										visible="<%=!editWellPermission%>"
										image="locked.png"
										tooltip="<%=item.hasBeenUsed() ? "This well has already been used" : "This well is locked for modification"%>"
									/>
								</tbl:cell>
								<tbl:cell column="bioMaterial.description"><base:propertyvalue item="<%=item%>" property="bioMaterial.description"/></tbl:cell>
								<tbl:cell column="bioMaterial.entryDate" value="<%=creationEvent == null ? null : creationEvent.getEntryDate() %>" />
								<tbl:cell column="originalBioMaterial.name"><base:propertyvalue item="<%=item%>" property="originalBioMaterial" /></tbl:cell>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
								<%=biowells == null || biowells.getTotalCount() == 0 ? "No biowells were found" : "No biowells on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</t:tab>
		
		<t:tab id="events" title="Plate events" />
		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items" />
		<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>" />
		</t:tabcontrol>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (biowells != null) biowells.close();
	if (dc != null) dc.close();
}
%>