<%-- $Id: annotate.jsp 6319 2013-09-09 07:56:59Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	
	@author Nicklas
	@version 2.0
--%>
<%@page import="org.json.simple.JSONObject"%>
<%@page import="org.json.simple.JSONArray"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.AnnotatableProxy"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.NameableComparator"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.TreeSet"
	import="java.util.Map"
	import="java.util.HashMap"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
private String minMax(Object min, Object max)
{
	StringBuilder minMax = new StringBuilder();
	if (min != null && max != null)
	{
		minMax.append(": ").append(min).append("‒").append(max);
	}
	else if (min != null)
	{
		minMax.append(" >= ").append(min);
	}
	else if (max != null)
	{
		minMax.append(" <= ").append(max);
	}
	return minMax.toString();
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final int protocolId = Values.getInt(request.getParameter("protocol_id"), -1);
final int subtypeId = Values.getInt(request.getParameter("subtype_id"), -1);
final int annotationTypeId = Values.getInt(request.getParameter("annotationtype_id"));
final boolean standalone = Values.getBoolean(request.getParameter("standalone"));

final DbControl dc = sc.newDbControl();
try
{
	// Date and time formats
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String dateTimeFormat = FormatterSettings.getDateTimeFormat(sc);
	String htmlDateTimeFormat = HTML.encodeTags(dateTimeFormat);
	
	// Load the current item and it's protocol
	// NOTE! User may have selected a different protocol in the form than what is
	// currently saved so if a protocol_id is sent in the request we use that
	final Annotatable item = itemId == 0 ? null : (Annotatable)itemType.getById(dc, itemId);
	final boolean writePermission = item == null ? true : item.hasPermission(Permission.WRITE);
	Protocol protocol = null;
	boolean readProtocol = true;
	try
	{
		if (protocolId == - 1 && item != null)
		{
			protocol = item.getProtocol();
		}
		else if (protocolId > 0)
		{
			protocol = Protocol.getById(dc, protocolId);
		}
	}
	catch (PermissionDeniedException ex)
	{
		readProtocol = false;
	}
	
	// Load the current subtype
	// NOTE! User may have selected a different subtype in the form than what is
	// currently saved so if a subtype_id is sent in the request we use that
	String selectedCategoryName = null;
	try
	{
		ItemSubtype subtype = null;
		if (subtypeId > 0)
		{
			subtype = ItemSubtype.getById(dc, subtypeId);
		}
		else if (item instanceof Subtypable)
		{
			subtype = ((Subtypable)item).getItemSubtype();
		}
		else if (item instanceof BioPlate)
		{
			BioPlateType bpt = ((BioPlate)item).getBioPlateType();
			subtype = bpt.getItemSubtype();
			if (subtype == null) selectedCategoryName = bpt.getName();
		}
		if (subtype != null) selectedCategoryName = subtype.getName();
	}
	catch (PermissionDeniedException ex)
	{}
	
	if (standalone)
	{
		sc.getCurrentContext(itemType).setObject("item", item);	
	}

	String title = "Annotate " + 
		HTML.encodeTags((item instanceof Nameable ? ((Nameable)item).getName() : 
			(item == null ? " new item" : item.toString())));

	// Queries to retrieve annotation types and protocol parameters
	ItemQuery<AnnotationType> annotationTypeQuery = null;
	String message = null;
	if (item instanceof AnnotatableProxy)
	{
		AnnotatableProxy proxy = (AnnotatableProxy)item;
		annotationTypeQuery = Base.getAnnotationTypesQuery(proxy);
		message = proxy.getAnnotationMessage();
	}
	else
	{
		annotationTypeQuery = Base.getAnnotationTypesQuery(itemType, false);
	}
	final ItemQuery<AnnotationType> parameterQuery = Base.getProtocolParametersQuery(protocol);

	// Query to retrieve the categories of an annotation type
	final ItemQuery<AnnotationTypeCategory> categoryQuery = AnnotationTypeCategory.getQuery();
	categoryQuery.include(Include.MINE, Include.OTHERS, Include.SHARED, Include.IN_PROJECT);
	categoryQuery.join(Hql.innerJoin("annotationTypes", "atp"));
	categoryQuery.restrict(Restrictions.eq(Hql.alias("atp"), Expressions.parameter("annotationType")));

	// Holds all categories that we have found
	final Set<AnnotationTypeCategory> allCategories = 
		new TreeSet<AnnotationTypeCategory>(new NameableComparator(false));
	
	// Load existing annotations
	AnnotationSet as = null;
	Map<AnnotationType, Annotation> existing = new HashMap<AnnotationType, Annotation>();
	if (item != null && item.isAnnotated())
	{
		// Load the existing annotations
		as = item.getAnnotationSet();
		List<Annotation> annotations = as.getAnnotations().list(dc);
		for (Annotation a : annotations)
		{
			try
			{
				existing.put(a.getAnnotationType(), a);
			}
			catch (PermissionDeniedException ex)
			{}
		}
	}
	
	// Load all annotation types that available from multiple sources:
	// * As defined by the server admin for the current item type
	// * Existing on the current item
	// * Defined as protocol parameters for the current protocol
	Set<AnnotationType> annotationTypes = new TreeSet<AnnotationType>(new NameableComparator(false));
	Set<AnnotationType> protocolParameters = new HashSet<AnnotationType>();
	annotationTypes.addAll(annotationTypeQuery.list(dc));
	annotationTypes.addAll(existing.keySet());
	if (annotationTypeId != 0)
	{
		annotationTypes.add(AnnotationType.getById(dc, annotationTypeId));
	}
	if (parameterQuery != null) 
	{
		protocolParameters.addAll(parameterQuery.list(dc));
		annotationTypes.addAll(protocolParameters);
	}

	// Build JSON objects for all annotation types, the current values and annotation type categories
	JSONArray jsonAnnotations = new JSONArray();
	for (AnnotationType at : annotationTypes)
	{
		// Load existing values and unit if they exists
		Type valueType = at.getValueType();
		List values = null;
		Unit unit = at.getDefaultUnit();
		if (existing != null && existing.containsKey(at))
		{
			Annotation a = existing.get(at);
			unit = a.getUnit();
			values = a.getValues(null);
		}
		if (at.isRemoved() && values == null) continue;
		
		JSONObject jsonAt = new JSONObject();
		JSONArray jsonValues = new JSONArray();
		JSONArray jsonCategories = new JSONArray();
		jsonAt.put("id", at.getId());
		jsonAt.put("name", at.getName());
		jsonAt.put("valueType", valueType.name());
		jsonAt.put("multiplicity", at.getMultiplicity());
		jsonAt.put("enumeration", at.isEnumeration());
		jsonAt.put("parameter", protocolParameters.contains(at));
		jsonAt.put("unit", unit == null ? 0 : unit.getId());
		jsonAt.put("values", jsonValues);
		jsonAt.put("categories", jsonCategories);
		jsonAnnotations.add(jsonAt);
		
		// Populate the values array
		if (values != null)
		{
			for (Object value : values)
			{
				// Dates should be formatted to strings using the current date(time) format
				if (value instanceof Date) 
				{
					if (valueType == Type.TIMESTAMP)
					{
						value = dateTimeFormatter.format((Date)value);
					}
					else
					{
						value = dateFormatter.format((Date)value);
					}
				}
				jsonValues.add(value.toString());
			}
		}
		// Populate the categories
		boolean checkCategoryNameAgainstSubtype = at.getId() == annotationTypeId;
		boolean foundCategoryForSubtype = false;
		categoryQuery.setParameter("annotationType", at.getId(), Type.INT);
		for (AnnotationTypeCategory category : categoryQuery.list(dc))
		{
			if (checkCategoryNameAgainstSubtype)
			{
				if (category.getName().equals(selectedCategoryName)) foundCategoryForSubtype = true;
			}
			allCategories.add(category);
			jsonCategories.add(category.getId());
		}
		if (checkCategoryNameAgainstSubtype && !foundCategoryForSubtype) selectedCategoryName = null;
	}
	%>
	<base:page type="<%=standalone ? "popup" : "iframe"%>" title="<%=title%>">
	<base:head scripts="~annotate.js" styles="parameters.css" />
	<base:body>
		<%
		if (standalone)
		{
			%>
			<h1><%=title%> <base:help helpid="annotations.edit" /></h1>
			<div class="content">
			<%
		}
		%>
		<div id="page-data" class="datacontainer"
			data-annotations="<%=HTML.encodeTags(jsonAnnotations.toJSONString()) %>"
			data-annotation-type-id="<%=annotationTypeId%>"
			data-date-format="<%=htmlDateFormat%>"
			data-datetime-format="<%=htmlDateTimeFormat%>"
			></div>
		<form name="annotations">
		
		<div class="absolutefull">
			<div class="absolutefull filled rightborder" style="width: 18em;">
				<div class="absolutefull" style="height: 2em;">
					<table style="margin: auto; height: 100%;"><tr><td>
					<select name="categories" id="categories" style="width: 17em;">
					<option value="-1">- all -
					<%
					if (protocol != null)
					{
						%>
						<option value="-2">- protocol parameters -
						<%
					}
					%>
					<option value="0">- uncategorized -
					<%
					for (AnnotationTypeCategory category : allCategories)
					{
						boolean selected = category.getName().equals(selectedCategoryName);
						%>
						<option value="<%=category.getId()%>"
							title="<%=HTML.encodeTags(category.getDescription())%>"
							<%=selected ? "selected" : "" %>
						><%=HTML.encodeTags(category.getName())%>
						<%
					}
					%>
					</select>
					</td></tr></table>
				</div>
				
				<div class="absolutefull parameterlist topborder" 
					style="top: 2em; bottom: 3em;">
					<%
					if (annotationTypes.size() == 0)
					{
						%>
						<div class="messagecontainer error">
							There are no annotation types defined for this kind of item.
						</div>
						<%
					}
					else
					{
						for (AnnotationType at : annotationTypes)
						{
							boolean isParameter = protocolParameters.contains(at);
							String label = HTML.encodeTags(at.getName());
							String icon = "";
							if (at.isRemoved()) icon += "<img src=\"../../images/deleted.png\" alt=\"\">";
							if (protocolParameters.contains(at)) icon += "<img src=\"../../images/parameter.png\" alt=\"\">";
							%>
							<div class="param" id="prompt.<%=at.getId()%>" title="<%=label%>" data-annotation-type-id="<%=at.getId()%>">
								<span class="icon"><img id="icon.<%=at.getId()%>" src="../../images/notrequired_novalues.gif" alt=""></span>
								<span class="label"><%=icon%><%=label%></span>
							</div>
							<%
						}
					}
					%>
				</div>
				<div class="absolutefull topborder" style="top: auto; bottom: 0px; height: 3em;">
					<table style="height: 100%; margin:auto;"><tr><td>
					<base:icon image="hasvalues.gif" /> = has value(s)<br>
					<base:icon image="parameter.png" /> = protocol parameter
					</td></tr></table>
				</div>
			</div>
			
			<div class="absolutefull input100" style="left: 18em; padding: 8px;">
				<%
				if (message != null)
				{
					%>
					<div class="messagecontainer help" style="margin-top: 0.2em;"><%=message%></div>
					<%
				}
				if (!writePermission)
				{
					%>
					<div class="messagecontainer error">You do not have permission to change this information</div>
					<%
				}
				%>
				<div id="valuecontainer" style="display: none;">
					<b>Values</b> <span id="multiplicity"></span><br>
					<select name="multi-values" id="multi-values" size="5" style="width: 100%;">
					</select>
					<table>
					<tr>
						<td><base:button id="btnMultiAdd" title="Add" tooltip="Add a new value" /></td>
						<td><base:button id="btnMultiRemove" title="Remove" tooltip="Remove the selected values"/></td>
					</tr>
					</table>
				<br>
				</div>
				<%
				for (AnnotationType at : annotationTypes)
				{
					Annotation a = as != null && as.hasAnnotation(at) ? as.getAnnotation(at) : null;
					int multiplicity = at.getMultiplicity();
					String inputName = "value."+at.getId();
					Type valueType = at.getValueType();
					%>
					<div id="section.<%=at.getId()%>" style="display: none;">
					<%
					if (at.isEnumeration())
					{
						String select = null;
						if (multiplicity == 0)
						{
							select = "Select one or more";
						}
						else if (multiplicity == 1)
						{
							select = "Select one";
						}
						else
						{
							select = "Select 1‒"+multiplicity;
						}
						List<?> values = at.getValues();
						Formatter f = FormatterFactory.getTypeFormatter(sc, at.getValueType());
						String unitSymbol = "";
						if (at.supportUnits()) unitSymbol = "&nbsp;" + at.getDefaultUnit().getDisplaySymbol();
						%>
						<b><%=HTML.encodeTags(at.getName())%></b> (<%=select%>)<br>
						<%
						if (at.getDisplayAsList())
						{
							if (multiplicity == 1)
							{
								%>
								<select name="<%=inputName%>" id="<%=inputName%>" class="auto-init" data-auto-init="detect-change">
								<option value="" style="font-style: italic;">- not specified -
								<%
							}
							else
							{
								%>
								<select name="<%=inputName%>" multiple size="10" class="auto-init" data-auto-init="detect-change">
								<%
							}
							for (Object value : values)
							{
								String encoded = f.format(value);
								%>
								<option value="<%=encoded%>"><%=encoded%><%=unitSymbol%>
								<%
							}
							%>
							</select>
							<%
						}
						else
						{
							String checkType = multiplicity == 1 ? "radio" : "checkbox";
							int i = 0;
							if (multiplicity == 1)
							{
								%>
								<input name="<%=inputName%>" id="<%=inputName%>.0" type="radio" class="auto-init" data-auto-init="detect-change" 
									checked value=""><label for="<%=inputName%>.0"><i>- not specified -</i></label><br>
								<%
								i++;
							}
							for (Object value : values)
							{
								String encoded = f.format(value);
								%>
								<input name="<%=inputName%>" id="<%=inputName%>.<%=i%>" type="<%=checkType%>" class="auto-init" data-auto-init="detect-change"
									value="<%=encoded%>"><label for="<%=inputName%>.<%=i%>"><%=encoded%><%=unitSymbol%></label><br>
								<%
								i++;
							}
						}
					}
					else if (valueType == Type.INT || valueType == Type.LONG)
					{
						%>
						<b><%=HTML.encodeTags(at.getName())%></b>
						(<%=valueType.toString()%><%=minMax(at.getMinValueLong(), at.getMaxValueLong())%>)<br>
						<input class="text auto-init" data-auto-init="detect-change" type="text" name="<%=inputName%>" id="<%=inputName%>" value="" style="width: 12em;" maxlength="20">
						<%
					}
					else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
					{
						%>
						<b><%=HTML.encodeTags(at.getName())%></b>
						(<%=valueType.toString()%><%=minMax(at.getMinValueDouble(), at.getMaxValueDouble())%>)<br>
						<input class="text auto-init" data-auto-init="detect-change" type="text" name="<%=inputName%>" id="<%=inputName%>" value="" style="width: 12em;" maxlength="20">
						<%
					}
					else if (valueType == Type.STRING)
					{
						Integer maxLength = at.getMaxLength();
						if (maxLength == null) maxLength = 255;
						%>
						<b><%=HTML.encodeTags(at.getName())%></b> (String)<br>
						<input class="text auto-init" data-auto-init="detect-change" type="text" name="<%=inputName%>" id="<%=inputName%>" value="" maxlength="<%=maxLength%>">
						<%
					}
					else if (valueType == Type.TEXT)
					{
						int height = at.getHeight() <= 0 ? 6 : at.getHeight();
						if (height > 20) height = 20;
						%>
						<b><%=HTML.encodeTags(at.getName())%></b> (Text)<br>
						<table style="width: 100%;">
						<tr>
							<td>
							<textarea class="text auto-init" data-auto-init="detect-change" name="<%=inputName%>" id="<%=inputName%>" rows="<%=height%>"></textarea>
							</td>
							<td style="width: 20px;">
								<base:zoom textarea="<%=inputName%>" title="<%=HTML.encodeTags(at.getName())%>" tooltip="Edit in larger window" />
							</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.BOOLEAN)
					{
						%>
						<b><%=HTML.encodeTags(at.getName())%></b><br>
						<input type="radio" name="<%=inputName%>" id="<%=inputName%>.null" value="" checked
							class="auto-init" data-auto-init="detect-change"><label for="<%=inputName%>.null"><i>- not specified -</i></label><br>
						<input type="radio" name="<%=inputName%>" id="<%=inputName%>.true" value="true" 
							class="auto-init" data-auto-init="detect-change"><label for="<%=inputName%>.true">true</label><br>
						<input type="radio" name="<%=inputName%>" id="<%=inputName%>.false" value="false" 
							class="auto-init" data-auto-init="detect-change"><label for="<%=inputName%>.false">false</label>
						<%
					}
					else if (valueType == Type.DATE)
					{
						%>
						<table>
						<tr>
						<td>
							<b><%=HTML.encodeTags(at.getName())%></b> (Date)<br>
							<input class="text auto-init" data-auto-init="detect-change" type="text" name="<%=inputName%>" id="<%=inputName%>" value="" style="width: 15em;"
								maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						</td>
						<td>
								<br>
								<base:button 
									id="<%="btn."+at.getId()%>"
									image="calendar.png"
									title="Calendar&hellip;" 
									tooltip="Select a date from a calendar"
								/>
						</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.TIMESTAMP)
					{
						%>
						<table>
						<tr>
						<td>
							<b><%=HTML.encodeTags(at.getName())%></b> (Timestamp)<br>
							<input class="text auto-init" data-auto-init="detect-change" type="text" name="<%=inputName%>" id="<%=inputName%>" value="" style="width: 20em;"
								maxlength="30" title="Enter date + time in format: <%=htmlDateTimeFormat%>">
						</td>
						<td>
								<br>
								<base:button 
									id="<%="btn."+at.getId()%>"
									image="calendar.png"
									title="Calendar&hellip;" 
									tooltip="Select date and time from a calendar" 
								/>
						</td>
						</tr>
						</table>
						<%
					}
					if (at.supportUnits() && !at.isEnumeration())
					{
						ItemQuery<Unit> unitQuery = at.getUsableUnits();
						if (unitQuery.count(dc) == 0)
						{
							unitQuery = at.getQuantity().getUnits();
						}
						else
						{
							unitQuery.reset();
						}
						unitQuery.order(Orders.desc(Hql.property("referenceFactor")));
						unitQuery.order(Orders.asc(Hql.property("displaySymbol")));
						List<Unit> units = unitQuery.list(dc);
						Unit current = a != null ? a.getUnit() : null;
						if (current == null) current = at.getDefaultUnit();
						%>
						<select name="unit.<%=at.getId()%>" id="unit.<%=at.getId()%>">
						<%
						boolean hasSelected = false;
						for (Unit unit : units)
						{
							String selected = "";
							if (unit.equals(current))
							{
								selected = " selected";
								hasSelected = true;
							}
							%>
							<option value="<%=unit.getId()%>" <%=selected%> 
								title="<%=HTML.encodeTags(unit.getName() + " - " + unit.getDescription()) %>"
								><%=HTML.encodeTags(unit.getDisplaySymbol())%>
							<%
						}
						if (!hasSelected && current != null)
						{
							%>
							<option value="<%=current.getId()%>" selected 
								title="<%=HTML.encodeTags(current.getName() + " - " + current.getDescription()) %>"
								><%=HTML.encodeTags(current.getDisplaySymbol())%>
							<%
						}
						%>
						</select>
						<%
					}
					if (at.getDescription() != null)
					{
						%>
						<div class="messagecontainer help" style="margin-left: 0px; margin-right: 0px;">
						<%=HTML.niceFormat(at.getDescription())%>
						</div>
						<%
					}
					%>
					</div>
					<%
				}
				%>
			</div>
		</div>
		</form>
		<%
		if (standalone)
		{
			%>
			</div>
			<base:buttongroup subclass="dialogbuttons topborder">
				<base:button id="btnSave" title="Save" visible="<%=writePermission%>" />
				<base:button id="close" title="Cancel"  visible="<%=writePermission%>" />
				<base:button id="close" title="Close" visible="<%=!writePermission%>" />
			</base:buttongroup>
			<form name="modified" method="post" action="index.jsp?ID=<%=ID%>">
				<input type="hidden" name="cmd" value="SaveAnnotations">
				<input type="hidden" name="item_type" value="<%=itemType.name()%>">
				<input type="hidden" name="item_id" value="<%=itemId%>">
			</form>
			<%
		}
		%>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
