<%-- $Id: select_file.jsp 6305 2013-08-09 09:10:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.AutoDetectingImporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext currentContext = sc.getCurrentContext(itemType, subContext);
final GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
final GuiContext context = new GuiContext(itemType, contextType);
final String title = request.getParameter("title");
final DbControl dc = sc.newDbControl();
final int pluginId = Values.getInt(request.getParameter("plugindefinition_id"));
PluginDefinition plugin = null;
if (pluginId > 0)
{
	plugin = PluginDefinition.getById(dc, pluginId);
}

try
{
	// Try to get data files attached to FileStoreEnabled items
	File currentFile = null;
	List<FileSetMember> dataFiles = null;
	if (itemType.getItemClass() != null && 
		FileStoreEnabled.class.isAssignableFrom(itemType.getItemClass()))
	{
		FileStoreEnabled fileStoreItem = null;
		try
		{
			fileStoreItem = (FileStoreEnabled)itemType.getById(dc, currentContext.getId());
		}
		catch (Throwable t)
		{}
		if (fileStoreItem != null && fileStoreItem.hasFileSet())
		{
			dataFiles = fileStoreItem.getFileSet().getMembers().list(dc);
			if (dataFiles.size() > 0)
			{
				// The first file will be selected by default
				try
				{
					currentFile = dataFiles.get(0).getFile();
				}
				catch (Throwable t)
				{}
			}
		}
	}
	List<File> recentFiles = (List<File>)currentContext.getRecent(dc, Item.FILE);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="~select_file.js" />
	<base:body>
		<h1><%=title%> (auto-detect file format) <base:help helpid="import.autodetect.selectfile" /></h1>
		
		<div id="page-data" class="datacontainer"
			data-default-charset="<%=Config.getCharset()%>"
		></div>
		
		<form name="import" action="index.jsp" method="get">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="AutoDetect">
		<input type="hidden" name="item_type" value="<%=itemType.name()%>">
		<input type="hidden" name="subcontext" value="<%=subContext%>">
		<input type="hidden" name="context_type" value="<%=contextType.name()%>">
		<input type="hidden" name="title" value="<%=title%>">
		<input type="hidden" name="job_name" value="<%=HTML.encodeTags(request.getParameter("job_name"))%>">
		<input type="hidden" name="job_description" value="<%=HTML.encodeTags(request.getParameter("job_description"))%>">
		<input type="hidden" name="plugindefinition_id" value="<%=request.getParameter("plugindefinition_id")%>">
		<input type="hidden" name="file_id" value="">
		
		<div class="content bottomborder">
			<div class="absolutefull filled" style="height: 4.5em;">
				<table style="height: 100%; margin: auto;"><tr><td>
				Select a file to import from.
				</td></tr></table>
			</div>
			
			<div class="absolutefull topborder" style="top: 4.5em;">
				<table class="fullform input100">
				<tr>
					<th>Plugin</th>
					<td><%=plugin != null ? HTML.encodeTags(plugin.getName()) : "<i>- all -</i>"%></td>
				</tr>
				<tr>
					<th>File</th>
					<td>
						<table style="width: 100%;">
						<tr>
							<td style="width: 98%;"><input type="text" class="text required" name="path" id="path"
								value="<%=currentFile != null ? HTML.encodeTags(currentFile.getPath().toString()) : "" %>"></td>
							<td><base:button 
									id="btnBrowse"
									title="Browse&hellip;"
									/></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th>Character set</th>
					<td>
						<select name="charset">
						<%
						String defaultCharset = Config.getCharset();
						int numCommon = Config.getCommonCharsets().size();
						int i = 0;
						for (String charset : Config.getAllCharsets())
						{
							%>
							<option value="<%=charset%>" 
								<%=defaultCharset.equalsIgnoreCase(charset) ? "selected" : ""%> 
								<%=i==numCommon ? "style=\"border-top: 1px solid #666666;\"" : "" %>><%=charset%>
							<%
							i++;
						}
						%>
						</select>
					</td>
				</tr>
				<%
				if (dataFiles != null && dataFiles.size() > 0)
				{
					%>
					<tr>
						<th>Data files</th>
						<td>
							<select name="dataFile" id="dataFile">
							<option value="">
							<%
							for (FileSetMember member : dataFiles)
							{
								File file = null;
								DataFileType dft = null;
								try
								{
									dft = member.getDataFileType();
								}
								catch (Throwable t)
								{}
								try
								{
									file = member.getFile();
								}
								catch (Throwable t)
								{}
								if (file != null)
								{
									String path = HTML.encodeTags(file.getPath().toString());
									String type = dft != null ? "[" + HTML.encodeTags(dft.getName()) + "] " : "";
									%>
									<option value="<%=file.getId()%>"><%=type%><%=path%>
									<%
								}
							}
							%>
							</select>
						</td>
					</tr>
					<%
				}
				%>
				<%
				if (recentFiles.size() > 0)
				{
					%>
					<tr>
						<th>Recently used</th>
						<td>
							<select name="recentFile" id="recentFile">
							<option value="">
							<%
							for (File recent : recentFiles)
							{
								String path = HTML.encodeTags(recent.getPath().toString());
								%>
								<option value="<%=recent.getId()%>"><%=path%>
								<%
							}
							%>
							</select>
						</td>
					</tr>
					<%
				}
				%>
				<tr class="dynamic">
					<th></th>
					<td></td>
				</tr>
				</table>
			</div>
		</div>
		</form>
	
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>
	
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnNext" title="Next" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

