/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Footnote = function()
{
	var pAutoReload = 60; // seconds until automatic page reload
	var footnote = {};
	
	/**
		Initialize the page.
	*/
	footnote.initPage = function()
	{
		// Broadcast message popup
		Buttons.addClickHandler('broadcast', footnote.showBroadcastMessage);
		Buttons.addClickHandler('singleMessage', footnote.singleMessageOnClick)
		Buttons.addClickHandler('multiMessages', footnote.showAllMessages);
		
		// Reload the footnote in 60 seconds
		Footnote.startReloadTimer();
	}
	
	/**
		Start the reload timer. Timeout parameter (in seconds) is optional.
		If not given, the default timout is used (60 seconds).
	*/
	footnote.startReloadTimer = function(timeout)
	{
		setTimeout(Footnote.reload, (timeout || pAutoReload) * 1000);
	}
	
	/**
		Reload the footnote page.
	*/
	footnote.reload = function()
	{
		location.reload(false);
	}
	
	/**
		Show a popup with the broadcast message.
	*/
	footnote.showBroadcastMessage = function()
	{
		Dialogs.openPopup(App.getRoot()+'info/broadcast.jsp', 'BroadcastMessage', 450, 300);
	}
	
	/**
		'click' handler for showing a single message in a popup
	*/
	footnote.singleMessageOnClick = function(event)
	{
		var messageId = Data.get(event.currentTarget, 'message-id');
		if (!messageId) return;
		Items.viewItem('MESSAGE', messageId);
		Footnote.startReloadTimer(1);
	}
	
	/**
		Show all messages in the main frame.
	*/
	footnote.showAllMessages = function()
	{
		window.top['main'].location.href = App.getRoot()+'my_base/messages/index.jsp?ID='+App.getSessionId();
	}
	
	return footnote;
}();

Doc.onLoad(Footnote.initPage);