/* $Id$
	------------------------------------------------------------------
	Copyright (C) 2014 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

*/

var Popup = function()
{
	var popup = {};
	var internal = {};
	var dx = 0;
	var dy = 0;
	
	var saveDialogPosition = false;
	
	// If the popup dialog is read-only BASE will not
	// display a warning when trying to re-open the same dialog
	popup.isReadOnly = function()
	{
		return Data.int(document.body, 'read-only');
	}
	
	// Need short delay to ensure that window is properly initialized
	internal.delayInitPosition = function()
	{
		saveDialogPosition = window.top.name && App.rememberDialogPositions();
		if (saveDialogPosition)	setTimeout(internal.initPosition, 500);
	}
	
	// Correct size of the window if the actual size is different from the requested
	// Firefox has -1 pixel height and IE has +4 pixels width and height
	internal.initPosition = function()
	{
		var key = 'dialog-position-req:'+window.top.name;
		var rpos = JSON.parse(App.getLocal(key));
//		alert('['+window.screenX+', '+window.screenY+'], ['+rpos.width+', ' + rpos.height+'], ['+window.innerWidth+', ' + window.innerHeight+'], [' + window.outerWidth+', '+window.outerHeight+']');
		if (rpos)
		{
			App.removeLocal(key);
			var cpos = App.getWindowPosition(window.top);
			dx = rpos.width-cpos.width;
			dy = rpos.height-cpos.height;
		}
	}
	
	internal.savePosition = function()
	{
		if (!saveDialogPosition || Data.int(document.body, 'no-dialog-position')) return;
		
		var pos = App.getWindowPosition(window.top);
		pos.width += dx;
		pos.height += dy;
		App.setLocal('dialog-position:'+window.top.name, JSON.stringify(pos));
	}
	
	document.addEventListener('DOMContentLoaded', internal.delayInitPosition, false);
	window.addEventListener('beforeunload', internal.savePosition, false);
	
	return popup;
}();



