<%-- $Id: create_wizard.jsp 6312 2013-08-28 11:48:06Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http://base.thep.lu.se/
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE.

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.ArrayBatch"	
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final Item itemType = Item.ARRAYSLIDE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{	
	String title = null;
	String name = "New slides.";
	
	boolean readCurrentArrayBatch = true;
	ArrayBatch currentArrayBatch = null;
	
	// Load recently used items
	List<ArrayBatch> recentArrayBatches = (List<ArrayBatch>)cc.getRecent(dc, Item.ARRAYBATCH);

	title = "Create array slides";
	cc.removeObject("item");
	int arrayBatchId = Values.getInt(request.getParameter("arraybatch_id"));
	if (arrayBatchId != 0)
	{
		currentArrayBatch = ArrayBatch.getById(dc, arrayBatchId);
	}
	else if (cc.getPropertyFilter("arrayBatch.name") != null)
	{
		currentArrayBatch = Base.getFirstMatching(dc, ArrayBatch.getQuery(), "name", cc.getPropertyFilter("arrayBatch.name"));
	}
	if (currentArrayBatch != null)
	{
		name = HTML.encodeTags(currentArrayBatch.getName()) + ".";
	}		
	%>
	<base:page type="popup" title="<%=title%>" id="<%=HTML.encodeTags(cmd)%>">
	<base:head scripts="~wizard.js" />
	<base:body>
		<%
		//Wizard step1
		if (cmd.equals("WizardStep1"))
		{
		%>				
			<h1><%=title%> <base:help helpid="arrayslide.createwizard.1" /></h1>
			<form action="create_wizard.jsp?ID=<%=ID%>" method="post" name="WizardStep1">
			<input type="hidden" name="cmd" value="WizardStep2">
			
			<div class="content bottomborder">
				<table class="fullform input100">
				<tr>
					<th>Name</th>
					<td><input class="text required auto-init" data-auto-init="focus-select"
						type="text" name="name"
						value="<%=name%>"
						maxlength="<%=ArraySlide.MAX_NAME_LENGTH%>"></td>
					<td></td>
				</tr>
				<tr>
					<th>Array batch</th>
					<td>
						<base:select 
							id="arraybatch_id"
							clazz="selectionlist required"
							required="true"
							current="<%=currentArrayBatch%>"
							denied="<%=!readCurrentArrayBatch%>"
							recent="<%=recentArrayBatches%>"
							newitem="true"
						/>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Quantity</th>
					<td><input class="text required" type="text" name="quantity" id="quantity" 
						value="50" maxlength="3" style="width: 5em;"><i> (1-999)</i></td>
					<td></td>
				</tr>
				<tr>
					<th>Start at</th>
					<td><input class="text" type="text" name="start_at" id="start_at" 
						value="1" maxlength="10" style="width: 10em;">
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">- pad size</th>
					<td>
						<input class="text" type="text" name="pad_length" id="pad_length" 
						value="" maxlength="1" style="width: 10em;">
					</td>
					<td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>
						<div class="messagecontainer help">
						The index number will be padded with zeroes to this length 
						(ie, 1 --&gt; Slide.001; 10 --&gt; Slide.010). Leave empty 
						for automatic selection. 
						</div>
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Description</th>
					<td>
						<textarea class="text" rows="6" name="description" id="description"
							><%=HTML.encodeTags(cc.getPropertyValue("description"))%></textarea>
					</td>
					<td style="width: 20px;">
						<base:zoom textarea="description" title="Description" />
					</td>
				</tr>
				</table>
				</div>
			</form>
		<%
		}
		//Wizard step 2
		else if (cmd.equals("WizardStep2"))
		{
			name = Values.getStringOrNull(request.getParameter("name"));
			String description = Values.getString(request.getParameter("description"), "");
			arrayBatchId = Values.getInt(request.getParameter("arraybatch_id"));
			int quantity = Values.getInt(request.getParameter("quantity"));
			int startAt = Values.getInt(request.getParameter("start_at"), 1);
			%>	
			<h1><%=title%> <base:help helpid="arrayslide.createwizard.2" /></h1>
			<form action="index.jsp?ID=<%=ID%>" method="post" name="WizardStep2">				
			<input type="hidden" name="cmd" value="CreateItems">
			<input type="hidden" name="description" value="<%=HTML.encodeTags(description)%>">
			<input type="hidden" name="arraybatch_id" value="<%=arrayBatchId%>">
			<input type="hidden" name="quantity" value="<%=quantity%>">
			<input type="hidden" name="start_at" value="<%=startAt%>">
			
			<div class="content bottomborder">

				<table class="fullform input100">
					<colgroup>
						<col style="max-width: 5em;">
						<col span="2" style="width: 47%;">
					</colgroup>
					<tbody class="sectionheader">
					<tr>
						<th>&nbsp;</th>
						<th>Name: 
							<base:icon 
								id="pasteMultipleName"
								data-form-prefix="name"
								image="paste.png" 
								tooltip="Paste multiple values in a single large textarea" 
							/>
							<base:icon 
								id="clearAllNames" 
								data-form-prefix="name"
								image="clear_down.png" 
								tooltip="Clear all values" 
							/>
						</th>
						<th>Barcode:
							<base:icon 
								id="pasteMultipleBarcode"
								data-form-prefix="barcode"
								image="paste.png"
								tooltip="Paste multiple values in a single large textarea" 
							/>
							<base:icon 
								id="clearAllBarcodes" 
								data-form-prefix="barcode"
								image="clear_down.png"
								tooltip="Clear all values" 
							/>
						</th>
					</tr>
					</tbody>
					<tbody>
					<%
					int padLength = Values.getInt(request.getParameter("pad_length"));
					if (padLength == 0)
					{
						int lastIndex = startAt + quantity - 1;
						padLength = (int)Math.log10(lastIndex) + 1;
					}
					for (int i = 0; i < quantity; i++)
					{
						int index = startAt + i;
						String paddedName = name + net.sf.basedb.util.MD5.leftPad(String.valueOf(index), '0', padLength);
						%>
						<tr>
							<th><%=index%></th>
							<td><input type="text" class="text required" name="name<%=i%>" 
								value="<%=paddedName%>" size="40" maxlength="<%=ArraySlide.MAX_NAME_LENGTH%>"></td>
							<td><input class="text" type="text" name="barcode<%=i%>"  
								size="40" maxlength="<%=ArraySlide.MAX_BARCODE_LENGTH%>">
							</td>							
						</tr>
						<%
					}
					%>
					<tr class="dynamic">
						<th></th>
						<td></td>
						<td></td>
					</tr>
					</tbody>
				</table>
				</div>
			</form>
			
		<%
		}
		%>		
		<div class="legend" style="height: 2em;">
			<base:icon image="required.png" />= required information
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" visible="<%=cmd.equals("WizardStep2")%>" />
			<base:button id="btnNext" title="Next" image="gonext.png" visible="<%=cmd.equals("WizardStep1")%>" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>
