<%-- $Id: view.jsp 6387 2013-12-18 13:03:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RawDataUtil"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.DynamicSpotQuery"
	import="net.sf.basedb.core.DynamicResultIterator"
	import="net.sf.basedb.core.VirtualColumn"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.data.RawData"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Dynamic"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Selects"
	import="net.sf.basedb.core.query.Aggregations"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.JoinType"
	import="net.sf.basedb.core.query.SqlResult"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.ExperimentExplorer.AnnotationSummary"
	import="net.sf.basedb.clients.web.ExperimentExplorer.AnnotationGroup"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.SpotImageFormatter"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.LinkedList"
	import="java.util.Collection"
	import="java.util.Arrays"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.HashMap"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.SPOTDATA;
	private static final String defaultReporterColumns = "filter,externalId,symbol";
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String root = request.getContextPath();

final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final DbControl dc = sc.newDbControl();
DynamicResultIterator spotData = null;
try
{
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String title = null;
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, bioAssaySetId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final RawDataType rawDataType = experiment.getRawDataType();
	final int channels = rawDataType.getChannels();
	final boolean hasRatio = channels == 2;
	final int maxRawMappings = bioAssaySet.getMaxRawMappingsForSpot();
	final IntensityTransform transform = bioAssaySet.getIntensityTransform();
	
	final ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bioAssaySet);
	final ItemContext cc = explorer.getAndSetSpotContext(sc, pageContext);
	final ItemContext reporterContext = explorer.getAndSetReporterContext(sc, null);
	final String subContext = cc.getSubContext();
	
	List<TableColumn> reporterColumns = new LinkedList<TableColumn>();
	DynamicUtil.addReporterColumns(reporterColumns, dc, experiment.getVirtualDb().getReporterCloneTemplate(), "", "@", "");

	List<TableColumn> spotColumns = new LinkedList<TableColumn>();
	DynamicUtil.addFormulaColumns(spotColumns, dc, rawDataType, Formula.Type.COLUMN_EXPRESSION, 
		transform, "frm.", "", maxRawMappings == 1);
	DynamicUtil.addExtraColumns(spotColumns, dc, bioAssaySet, "ev", "#", "[Xtra] ");
	if (maxRawMappings == 1)
	{
		DynamicUtil.addRawDataColumns(spotColumns, dc, rawDataType, "raw.", "$", "[Raw] ");
		spotColumns.add(new TableColumn("raw.spotimage", "$id", "raw('id')", Type.INT, 
			"[Raw] Spotimage", "", "auto", false, false, false, null, 
			new SpotImageFormatter(dc, rawDataType, root)));
	}

	final int matchingReporters = explorer.getMatchingReporters(dc);
	int reporterIndex = explorer.getReporterIndex();
	if (reporterIndex >= matchingReporters) reporterIndex = matchingReporters - 1;
	final ReporterData reporter = matchingReporters == 0 ? 
			null : explorer.getReporter(dc, reporterIndex);

	final int matchingPositions = matchingReporters == 0 ? 
			0 : explorer.getNumPositions(dc, reporterIndex);
	
	int positionIndex = explorer.getPositionIndex();
	if (positionIndex >= matchingPositions) positionIndex = matchingPositions - 1;
	final boolean isAveraging = positionIndex == ExperimentExplorer.SPOT_AVG;
	
	final List<AnnotationType> annotationTypes = explorer.getAnnotationTypes(dc, true);
	final Set<Integer> tmp = explorer.getAnnotationTypeIds();
	final Map<AnnotationType, AnnotationSummary> selectedAnnotationTypes = 
		new HashMap<AnnotationType, AnnotationSummary>(tmp.size());
	for (Integer atId : tmp)
	{
		try
		{
			selectedAnnotationTypes.put(AnnotationType.getById(dc, atId), null);
		}
		catch (Throwable t)
		{}
	}

	JSONArray jsonAnnotationTypes = new JSONArray();
	if (annotationTypes != null)
	{
		for (AnnotationType at : annotationTypes)
		{
			JSONObject jsonAt = new JSONObject();
			jsonAt.put("key", at.getId());
			jsonAt.put("value", at.getName());
			jsonAt.put("checked", selectedAnnotationTypes.containsKey(at));
			jsonAnnotationTypes.add(jsonAt);
		}
	}
	
	DynamicUtil.SelectedInfo selected = DynamicUtil.getSelectedColumns(cc, spotColumns, isAveraging);
	
	List<String> sortProperties = null;
	if (isAveraging && cc.getSortProperty() != null)
	{
		// We must check that we are not sorting on a non-averagable property
		sortProperties = new ArrayList<String>(Arrays.asList(cc.getSortProperty().split(",")));
		for (TableColumn tc : spotColumns)
		{
			if (!tc.isAveragable()) sortProperties.remove(tc.getProperty());
		}
		cc.setSortProperty(Values.getString(sortProperties, ",", true));
	}
	
	if (matchingReporters > 0)
	{
		for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
		{
			entry.setValue(explorer.getAnnotationSummary(dc, entry.getKey()));
		}
		try
		{
			DynamicSpotQuery spotQuery = explorer.getSpotQuery(dc, reporterIndex, positionIndex, selected.selectedColumns);
			spotData = spotQuery.iterate(dc);
		}
		catch (Throwable t)
		{
			cc.setMessage(t.getMessage());
			t.printStackTrace();
		}
	}
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol-2.js,~view.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,explorer.css">
	<style>
		.special td.cell:first-of-type
		{
			border-right: 1px solid #A0A0A0;
		}
	</style>
	</base:head>
	<base:body>
		<p:path><p:pathelement title="Experiments" href="<%="../../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&amp;experiment_id="+experiment.getId()%>" 
			/><p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&amp;cmd=ViewItem&amp;item_id="+bioAssaySetId%>" 
			/><p:pathelement title="Explorer" /></p:path>
		
		<t:tabcontrol
			id="explorer" 
			subclass="content mastertabcontrol"
			remember="false" active="view">
		<t:tab id="search" title="Reporter search" />
		
		<t:tab id="view" title="Reporter view">
		<%
		Collection<PropertyFilter> filters = reporterContext.getPropertyFilters();
		String filter = filters != null && filters.size() > 0 ? 
			Values.getString(filters, " AND ", true).replaceAll("@|�", "") : "- none -";
		if (reporter == null)
		{
			%>
			<table class="fullform bottomborder">
			<tr>
				<th>Filter</th>
				<td><%=HTML.encodeTags(filter)%></td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td>
					<div class="messagecontainer note">
					No reporters found.
					</div>
				</td>
			</table>
			<%
		}
		else
		{
			%>
			<form name="reporterIndex" action="index.jsp" method="post">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="bioassayset_id" value="<%=bioAssaySetId%>">
			<input type="hidden" name="cmd" value="SetReporterIndex">
			
			<tbl:toolbar subclass="bottomborder">
				<tbl:label style="padding: 0px 2px 0px 6px;">
					Current reporter
						<input name="newReporterIndex" id="newReporterIndex" 
							type="text" class="text" 
							value="<%=reporterIndex+1%>" data-max-index="<%=matchingReporters%>"
						style="width: 6em;" maxlength="8" title="Enter a number between 1 and <%=matchingReporters%>">
					of <%=matchingReporters %>
					<%
					if (reporterIndex == 0 || matchingReporters == 0)
					{
						%>
						<base:icon image="first.png" enabled="false" />
						<base:icon image="previous.png" enabled="false" />
						<%
					}
					else
					{
						%>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetReporterIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;reporterIndex=0"
							title="Go the first reporter"><base:icon image="first.png" /></a>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetReporterIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;reporterIndex=<%=reporterIndex-1%>"
							title="Go the previous reporter"><base:icon image="previous.png" /></a>
						<%
					}
					%>
					&nbsp;&nbsp;
					<%
					if (reporterIndex == matchingReporters - 1 || matchingReporters == 0)
					{
						%>
						<base:icon image="next.png" enabled="false" />
						<base:icon image="last.png" enabled="false" />
						<%
					}
					else
					{
						%>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetReporterIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;reporterIndex=<%=reporterIndex+1%>"
							title="Go the next reporter"><base:icon image="next.png" /></a>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetReporterIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;reporterIndex=<%=matchingReporters-1%>"
							title="Go the last reporter"><base:icon image="last.png" /></a>
						<%
					}
					%>
				</tbl:label>
				<tbl:button 
					id="btnReporterColumns"
					image="columns.png" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order reporter columns" 
				/>
			</tbl:toolbar>
			</form>
		
			<tbl:table 
				id="reporter" 
				columns="<%="filter,"+Values.getString(cc.getSetting("reporter-columns"), defaultReporterColumns)%>"
				action="index.jsp"
				sc="<%=sc%>"
				item="<%=itemType%>"
				subcontext="<%=subContext%>"
				subclass="bottomborder"
				>
				<tbl:hidden 
					name="bioassayset_id" 
					value="<%=String.valueOf(bioAssaySetId)%>" 
				/>
				<tbl:columndef 
					id="filter" 
					title="Filter"
					show="always"
				/>
				<%
				for (TableColumn tc : reporterColumns)
				{
					%>
					<tbl:columndef
						id="<%=tc.getId()%>"
						title="<%=HTML.encodeTags(tc.getTitle())%>"
						formatter="<%=tc.getFormatter()%>"
						show="<%=reporter == null ? "never" : "auto" %>"
					/>
					<%
				}
				List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
				%>
				<tbl:form width="2" clazz="fullform special">
					<tbl:cell column="filter"><%=HTML.encodeTags(filter)%></tbl:cell>
					<tbl:cell column="id"><%=reporter.getId()%></tbl:cell>
					<tbl:cell column="version"><%=reporter.getVersion()%></tbl:cell>
					<tbl:cell column="name"><%=Base.getLink(ID, reporter.getName(), Item.REPORTER, reporter.getId(), true)%></tbl:cell>
					<tbl:cell column="externalId"><%=Base.getLink(ID, reporter.getExternalId(), Item.REPORTER, reporter.getId(), true)%></tbl:cell>
					<tbl:cell column="symbol"><%=HTML.encodeTags(reporter.getSymbol())%></tbl:cell>
					<tbl:cell column="lastUpdate"><%=dateTimeFormatter.format(reporter.getLastUpdate())%></tbl:cell>
					<tbl:cell column="lastSource"><%=HTML.encodeTags(reporter.getLastSource())%></tbl:cell>
					<tbl:cell column="entryDate"><%=dateFormatter.format(reporter.getEntryDate()) %></tbl:cell>
					<tbl:cell column="type"><base:propertyvalue dbcontrol="<%=dc%>" item="<%=reporter%>" property="reporterType" /></tbl:cell>
					<tbl:cell column="description"><%=HTML.niceFormat(reporter.getDescription())%></tbl:cell>
					<%
					if (reporterProperties != null)
					{
						for (ExtendedProperty ep : reporterProperties)
						{
							String name = ep.getName();
							%>
							<tbl:cell column="<%=ep.getName()%>"><tbl:cellvalue value="<%=reporter.getExtended(name)%>" /></tbl:cell>
							<%
						}
					}
					%>
				</tbl:form>
			</tbl:table>
	
		<base:section
			id="annotation"
			title="<%="Annotation summary (" + selectedAnnotationTypes.size() + " selected)"%>"
			context="<%=cc%>"
			style="border-bottom: 0px;"
			>
			<form name="annotationSummary" action="index.jsp" method="POST">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="bioassayset_id" value="<%=bioAssaySetId%>">
			<input type="hidden" name="cmd" value="SetAnnotationType">
				<div class="multiselect auto-init" style="width: 25em;" data-auto-init="multiselect" 
					data-multiple="1" data-options="<%=HTML.encodeTags(jsonAnnotationTypes.toJSONString())%>">
					<table>
					<tr>
						<td><input type="text" class="text multiselect-display" name="display:annotationTypes" title="Click to select experimental factor"></td>
						<td class="dropdown">
							<base:icon image="mini_scroll_down.png" />
						</td>
						</tr>
					</table>
					<input type="hidden" class="multiselect-hidden" name="annotationtype_id" value="">
				</div>
					<%
					for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
					{
						AnnotationType at = entry.getKey();
						AnnotationSummary summary = entry.getValue();
						%>
						<table class="annotationsummary">
						<tr>
							<td class="summaryheader"><%=Base.getLinkedName(ID, at, false, true)%></td>
							<td class="plotheader"><base:icon
								subclass="link auto-init"
								data-auto-init="annotation-plot"
								data-annotation-type="<%=at.getId()%>"
								image="plotter.png"
								tooltip="Box plot for selected spot data per annotation group"
							/></td>
							<%
							for (AnnotationGroup ag : summary.getAnnotationGroups())
							{
								%>
								<td class="groupheader" style="background: <%=ag.getColor()%>;">
								<%=ag.getTitle()%>
								</td>
								<%
							}
							%>
							</tr>
							<%
							for (int ch = 1; ch <= channels; ++ch)
							{
								%>
								<tr>
								<td colspan="2">Mean ch <%=ch%> int.</td>
								<%
								for (AnnotationGroup ag : summary.getAnnotationGroups())
								{
									%>
									<td class="value" style="background: <%=ag.getColor()%>;"
										id="mean.<%=at.getId()%>.<%=ag.getId()%>.ch<%=ch%>"></td>
									<%
								}
								%>
								</tr>
								<%
							}
							if (hasRatio)
							{
								%>
								<tr>
								<td colspan="2" title="The geometric mean of the ratios">G. mean ratio</td>
								<%
								for (AnnotationGroup ag : summary.getAnnotationGroups())
								{
									%>
									<td class="value" style="background: <%=ag.getColor()%>;"
										id="gmean.<%=at.getId()%>.<%=ag.getId()%>"></td>
									<%
								}
								%>
								</tr>
								<tr>
								<td colspan="2" title="Standard deviation of log2 ratios">log2ratio SD</td>
								<%
								for (AnnotationGroup ag : summary.getAnnotationGroups())
								{
									%>
									<td class="value" style="background: <%=ag.getColor()%>;"
										id="sd.<%=at.getId()%>.<%=ag.getId()%>"></td>
									<%
								}
								%>
								</tr>
								<%
							}
							%>
							<tr>
							<td colspan="2" title="The number of spots falling in this group">Count</td>
							<%
							for (AnnotationGroup ag : summary.getAnnotationGroups())
							{
								%>
								<td class="value" style="background: <%=ag.getColor()%>;"
									id="count.<%=at.getId()%>.<%=ag.getId()%>"></td>
								<%
							}
							%>
							</tr>
						</table>
					<%
					}
				%>
			</form>
		</base:section>
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="messagecontainer error"><%=HTML.encodeTags(cc.getMessage())%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<%
		if (spotData != null)
		{
			Formatter<Number> numberFormatter = FormatterFactory.getNumberFormatter(sc);
			%>
			<form name="spotIndex" action="index.jsp" method="post">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="bioassayset_id" value="<%=bioAssaySetId%>">
			<input type="hidden" name="cmd" value="SetSpotIndex">
			<tbl:toolbar subclass="topborder">
				<tbl:label style="padding: 0px 2px 0px 6px;">
				Current spot
				<input name="newSpotIndex" id="newSpotIndex" 
					data-max-index="<%=matchingPositions%>"
					type="text" class="text" value="<%=positionIndex == -1 ? "all" : positionIndex == -2 ? "avg" : String.valueOf(positionIndex+1)%>" 
					size="6" maxlength="8" title="Enter a number between 1 and <%=matchingPositions%>">
					of <%=matchingPositions%>
					<%
					if (positionIndex == 0)
					{
						%>
						<base:icon image="first.png" enabled="false" />
						<%
					}
					else
					{
						%>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetSpotIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;spotIndex=0"
							title="Go the first position"><base:icon image="first.png" /></a>
						<%
					}
					if (positionIndex <= 0)
					{
						%>
						<base:icon image="previous.png" enabled="false" />
						<%
					}
					else
					{
						%>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetSpotIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;spotIndex=<%=positionIndex-1%>"
							title="Go the previous position"><base:icon image="previous.png" /></a>
						<%
					}
					%>
					&nbsp;&nbsp;
					<%
					if (positionIndex == matchingPositions - 1 || positionIndex < 0)
					{
						%>
						<base:icon image="next.png" enabled="false" />
						<%
					}
					else
					{
						%>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetSpotIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;spotIndex=<%=positionIndex+1%>"
							title="Go the next position"><base:icon image="next.png" /></a>
						<%
					}
					if (positionIndex == matchingPositions - 1)
					{
						%>
						<base:icon image="last.png" enabled="false" />
						<%
					}
					else
					{
						%>
						<a href="index.jsp?ID=<%=ID%>&amp;cmd=SetSpotIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;spotIndex=<%=matchingPositions-1%>"
							title="Go the last position"><base:icon image="last.png" /></a>
						<%
					}
					%>
					[ <a href="index.jsp?ID=<%=ID%>&amp;cmd=SetSpotIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;spotIndex=-1"
						title="Show all positions">all</a>
					| <a href="index.jsp?ID=<%=ID%>&amp;cmd=SetSpotIndex&amp;bioassayset_id=<%=bioAssaySetId%>&amp;spotIndex=-2"
						title="Calculate average values for each bioassay">avg</a>
					]
				</tbl:label>
				<tbl:button 
					id="btnSpotColumns"
					image="columns.png" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button 
					id="btnAssayPlot"
					image="plotter.png"
					title="Plot&hellip;"
					tooltip="Plot selected data from this table"
				/>
			</tbl:toolbar>
			</form>
			<tbl:table 
				id="spotdata" 
				columns="<%=cc.getSetting("columns")%>"
				sortby="<%=cc.getSortProperty()%>" 
				direction="<%=cc.getSortDirection()%>"
				action="index.jsp"
				sc="<%=sc%>"
				item="<%=itemType%>"
				subcontext="<%=subContext%>"
				>
				<tbl:hidden 
					name="bioassayset_id" 
					value="<%=String.valueOf(bioAssaySetId)%>" 
				/>
				<tbl:hidden 
					name="reporter_index" 
					value="<%=String.valueOf(reporterIndex)%>" 
				/>
				<tbl:hidden 
					name="position_index" 
					value="<%=String.valueOf(positionIndex)%>" 
				/>
				<%
				for (AnnotationType at : selectedAnnotationTypes.keySet())
				{
					%>
					<tbl:columndef
						id="<%="annotation." + at.getId()%>"
						title="<%=HTML.encodeTags(at.getName()) %>"
						show="always"
					/>
					<%
				}
				%>
				<tbl:columndef
					id="bioassay"
					property="COLUMN"
					title="Bioassay"
					show="always"
					sortable="true"
				/>
				<tbl:columndef
					id="position"
					property="POSITION"
					title="Position"
					show="<%=isAveraging ? "never" : "always" %>"
					sortable="true"
				/>
				<tbl:columndef
					id="count"
					title="Count"
					show="<%=isAveraging ? "always" : "never" %>"
				/>
				<%
				for (int ch = 1; ch <= channels; ++ch)
				{
					%>
					<tbl:columndef
						id="<%="ch"+ch%>"
						property="<%="%"+ch%>"
						datatype="float"
						title="<%="Ch " + ch%>"
						tooltip="<%=transform.isTransformed() ? transform.toString() : null %>"
						sortable="true"
						filterable="true"
						exportable="true"
						formatter="<%=numberFormatter%>"
					/>
					<%
				}
				%>
				<%
				for (TableColumn tc : spotColumns)
				{
					%>
					<tbl:columndef
						id="<%=tc.getId()%>"
						property="<%=tc.getProperty()%>"
						datatype="<%=tc.getDatatype().getStringValue()%>"
						title="<%=HTML.encodeTags(tc.getTitle())%>"
						sortable="<%=tc.getSortable()%>"
						filterable="<%=tc.getFilterable()%>"
						exportable="<%=tc.getExportable()%>"
						show="<%=!isAveraging || tc.isAveragable() ? tc.getShow() : "never"%>"
						formatter="<%=tc.getFormatter()%>"
					/>
					<%
				}
				%>
				<tbl:data style="border-left: 0px; border-right: 0px;">
					<tbl:headers>
						<tbl:headerrow>
							<tbl:columnheaders />
						</tbl:headerrow>
					</tbl:headers>
					<tbl:rows>
					<%
					int index = 0;
					float[] intensity = new float[channels+1];
					while (spotData.hasNext())
					{
						SqlResult item = spotData.next();
						index++;
						BioAssay bioAssay = explorer.getBioAssay(dc, item.getShort(1));
						for (int ch = 1; ch <= channels; ++ch)
						{
							intensity[ch] = item.getFloat(2+ch);
						}
						%>
						<tbl:row>
							<%
							for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
							{
								AnnotationType at = entry.getKey();
								AnnotationGroup annotationGroup = entry.getValue().getAnnotationGroup(bioAssay.getDataCubeColumnNo());
								String allValues = annotationGroup.getTitle();
								if (hasRatio)
								{
									float logRatio = (float)(Math.log(transform.unTransform(intensity[1]) / transform.unTransform(intensity[2])));
									annotationGroup.addStatistics("logratio", logRatio);
									annotationGroup.addStatistics("logratio2", logRatio * logRatio);
								}
								for (int ch = 1; ch <= channels; ++ch)
								{
									annotationGroup.addValue(ch, (float)transform.unTransform(intensity[ch]));
								}
								%>
								<tbl:cell column="<%="annotation."+at.getId()%>" style="<%="background: "+annotationGroup.getColor()+";"%>">
								<%=allValues%>
								</tbl:cell>
								<%
							}
							%>
							<tbl:cell column="bioassay"><%=Base.getLinkedName(ID, bioAssay, false, true)%></tbl:cell>
							<tbl:cell column="position"><%=item.getInt(2)%></tbl:cell>
							<tbl:cell column="count"><%=item.getInt(2)%></tbl:cell>
							<%
							for (int ch = 1; ch <= channels; ++ch)
							{
								%>
								<tbl:cell column="<%="ch" + ch%>" value="<%=intensity[ch]%>" />
								<%
							}
							%>
							<%
							int colIndex = 3 + channels;
							for (String columnId : selected.selectedIds)
							{
								%>
								<tbl:cell column="<%=columnId%>" value="<%=item.getObject(colIndex++)%>" />
								<%
							}
							%>
						</tbl:row>
						<%
					}
				%>
				</tbl:rows>
				</tbl:data>
			</tbl:table>
			<%
			}
			%>
			<%
			JSONArray jsonAnnotationSummary = new JSONArray();
			for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
			{
				AnnotationType at = entry.getKey();
				AnnotationSummary summary = entry.getValue();
				if (summary != null)
				{
					JSONObject jsonAnnotationType = new JSONObject();
					jsonAnnotationType.put("id", at.getId());
					jsonAnnotationSummary.add(jsonAnnotationType);
					
					JSONArray jsonGroups = new JSONArray();
					jsonAnnotationType.put("groups", jsonGroups);
					
					for (AnnotationGroup ag : summary.getAnnotationGroups())
					{
						JSONObject jsonGroup = new JSONObject();
						jsonGroups.add(jsonGroup);
						jsonGroup.put("id", ag.getId());
						jsonGroup.put("count", ag.getCount(1));
						
						JSONArray jsonCh = new JSONArray();
						jsonGroup.put("mean", jsonCh);
						for (int ch = 1; ch <= channels; ++ch)
						{
							jsonCh.add(Values.formatNumber(ag.getMean(ch), 2));
						}
						if (hasRatio)
						{
							float r = ag.getStatistics("logratio");
							int count = ag.getCount(1);
							float gMean = count > 0 ? (float)Math.exp(r / count) : Float.NaN;
							float sd = count > 1 ? 
								(float)Math.sqrt((ag.getStatistics("logratio2") - r * (r / count))/(count-1))
								: Float.NaN;
							jsonGroup.put("gmean", Values.formatNumber(gMean, 2));
							jsonGroup.put("sd", Values.formatNumber(sd, 2));
						}
					}
				}
			}
			%>
			<div id="annotation-summary" class="datacontainer"
				data-channels="<%=channels%>"
				data-summary="<%=HTML.encodeTags(jsonAnnotationSummary.toJSONString()) %>"
			></div>
			<%
		}
		%>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (spotData != null) spotData.close();
	if (dc != null) dc.close();
}

%>
